#!/system/bin/sh

Dev="@EstProject01 & @PersonPemula"
Vers="2.0-edition"
Credt="@PersonPemula"
Bt="All"
WelcomeProgram="Welcome to ExSon Performance + !"

# Expiry date (format: YYYYMMDD)
ExpiryDate="20240412"

# Function to check expiration
checkExpiration() {
  current_date=$(date "+%Y%m%d")
  if [ "$current_date" -gt "$ExpiryDate" ]; then
    echo ""
    echo " Error: The program has expired. Please contact the developer for an updated version."
    echo " New Update : Coming Soon !!!!"
    echo ""
    exit 1
  fi
}

# Call the function to check expiration before proceeding
checkExpiration

# Function untuk memberikan bantuan AI
EstProject_AI() {
  echo ""
  sleep 2
  echo "--------------------------------"
  echo "| $WelcomeProgram|"
  echo "--------------------------------"
  echo ""
  sleep 1
  echo ""
  sleep 1.5
  echo " ESTPROJECT AI: Hello, I'm here sharing modules from ${Dev}."
  sleep 1.5
  echo " ESTPROJECT AI: Feel free to ask ${Dev} if you have questions or need further assistance."
  sleep 1.5
  echo " ESTPROJECT AI: You can inquire about anything you need to know."
  sleep 1.5
  echo "---------------------------"
}

# Ask user if they want to continue with AI
echo ""
echo "Do you want to continue with the AI program? (y/n)"
read -r continue_with_ai

if [ "$continue_with_ai" != "y" ]; then
  echo "Exiting the program as per user's choice."
  exit 0
fi

# Call the AI Assistant function
EstProject_AI

# Auto Exit Program
AutoExitProgram() {
  echo ""
  echo "---------------------------"
  echo "|         AUTO EXIT        |"
  echo "---------------------------"
  echo " Installation stopped due to certain conditions not being met."
  echo "---------------------------"
  exit 1
}

# Check conditions before installation
if [ ! -f "/sdcard/ExSonPerf+/helperfiles.sh" ]; then
  AutoExitProgram
fi

# Device Information
AndroidVersion=$(getprop ro.build.version.release)
SDKVersion=$(getprop ro.build.version.sdk)
BuildType=$(getprop ro.build.type)
Manufacturer=$(getprop ro.product.manufacturer)
Model=$(getprop ro.product.model)
ProductName=$(getprop ro.product.name)
Hardware=$(getprop ro.hardware)
BuildRelease=$(getprop ro.build.date)

# Script
echo ""
sleep 1
echo "---------------------------"
echo "| EXSON PERFORMANCE + |"
echo "---------------------------"
sleep 1
echo ""
echo " Dev: > ${Dev} "
sleep 0.5
echo " Version: > ${Vers} "
sleep 0.5
echo " Credit: > ${Credt} "
sleep 0.5
echo " Thanks To: > ${Bt} "
sleep 0.5
echo ""
echo "---------------------------"
echo "|    DEVICE INFORMATION    |"
echo "---------------------------"
echo " Android Version: > $AndroidVersion"
echo " SDK Version: > $SDKVersion"
echo " Build Type: > $BuildType"
echo " Manufacturer: > $Manufacturer"
echo " Model: > $Model"
echo " Product Name: > $ProductName"
echo " Hardware: > $Hardware"
echo " Build Release: > $BuildRelease"
echo "---------------------------"
sleep 1

echo ""
echo "---------------------------"
echo "| WAITING FOR INSTALLATION |"
echo "---------------------------"
sleep 10

# Your program logic goes here...

echo ""
echo "---------------------------"
echo "| INSTALLATION SUCCESSFUL  |"
echo "---------------------------"
echo ""
sleep 3
setprop debug.thermal_zone.gpu_threshold_temp 95
setprop debug.thermal_zone.cpu_threshold_temp 90
setprop debug.thermal_zone.display_threshold_temp 80
setprop debug.thermal_zone.camera_hotplug_control 2
setprop debug.thermal_zone.battery_threshold_temp 60
setprop debug.thermal_zone.camera_threshold_temp 85
setprop debug.thermal_zone.cpu_hotplug_control 2
setprop debug.thermal_zone.gpu_hotplug_control 2
cmd package compile -m everything -f com.dts.freefireth
settings put global power_check_max_cpu_1 25
settings put global power_check_max_cpu_2 25
settings put global power_check_max_cpu_3 10
settings put global power_check_max_cpu_4 2
cmd activity kill-all
setprop debug.show_refresh_rate_overlay_spinner 7236
setprop debug.sf.max_igbp_list_size 7236
setprop debug.gpu.scheduler_pre.emption 1
settings put global low_power 0
settings put global low_power_sticky 0
settings put global NON_DISPATCHABLE_HANDLE 25
settings put global wifi_scan_always_enabled 0
settings put global low_power_exceptions 0
settings put global native_memtag_sync 1
settings put global native_heap_zero_init 1
settings put global gpu_renderer_policy 1
settings put global gpu_composition_policy 1
settings put global gpu_render_policy 1
settings put global enable_hw_2d 1
settings put global enable_hw_3d 1
settings put global fstrim_mandatory_interval 86400000
setprop debug.game.fps.engine.type max-perf
setprop debug.hwui.target_power_time_percent 100
setprop debug.hwui.target_cpu_time_percent 100
setprop debug.hwui.target_gpu_time_percent 100
setprop debug.hwui.use_hint_manager true
setprop debug.choreographer.skipwarning 1440000
setprop debug.multicore.processing 1
setprop debug.disable_sched_boost true
setprop debug.gr.swapinterval 0
setprop debug.dev.ssrm.turbo true
setprop debug.sf.early_phase_offset_ns 500000
setprop debug.sf.early_app_phase_offset_ns 500000
setprop debug.sf.early_gl_phase_offset_ns 3000000
setprop debug.sf.early_gl_app_phase_offset_ns 15000000
setprop debug.sf.high_fps_early_phase_offset_ns 6100000
setprop debug.sf.high_fps_early_gl_phase_offset_ns 650000
setprop debug.sf.high_fps_late_app_phase_offset_ns 100000
setprop debug.sf.phase_offset_threshold_for_next_vsync_ns 6100000
setprop debug.egl.force_msaa false
setprop debug.egl.force_fxaa false
setprop debug.egl.force_taa false
setprop debug.egl.force_smaa false
setprop debug.egl.force_txaa false
pm trim-caches 100G
cmd thermalservice override-status 0
cmd power set-fixed-performance-mode-enabled true
setprop debug.enable-vr-mode 1
setprop debug.force-opengl 1
setprop debug.hwc.force_gpu_vsync 1
setprop debug.performance.profile 1
setprop debug.refresh_rate.min_fps 90
settings put system touch.size.isSummed 0
settings put system view.touch_slop 2
settings put system touch_response_dfl 0
settings put system wifi_idle_ms 5000
settings put system sysui_qqs_count 5
settings put system power_saving_gps_sleep_duration 3600000
settings put system mount_adoptable 1
settings put system tcp_default_init_rwnd 60
settings put system sdcardfs_tuneable 16384
settings put system high_mode 1
setprop debug.cpu.driver_use_multicore true
setprop debug.sf.latch_unlocked 1
setprop debug.audio.repair.ai true
setprop debug.little_cpu_count 1
setprop debug.big_cpu_count 7
setprop debug.big_core_threshold 30
setprop debug.cpu_big_cluster_suspended 1
setprop debug.cpu_core_ctl_max_cores 8
setprop debug.cpu_core_ctl_offline_delay_ms 500